'use strict';

exports.__esModule = true;
var REGEX = /(\w[_\-\s\.]+\w|[a-z][A-Z])/g;
var clean = function clean(str) {
	return str.replace(/(^[_\-\s\.]+|[_\-\s\.]+$)/g, '');
};
var firstChar = function firstChar(str) {
	return str.slice(0, 1);
};
var lastChar = function lastChar(str) {
	return str.slice(-1);
};
var throwTypeError = function throwTypeError(str) {
	throw new TypeError(str + ' must be a string');
};
var isString = function isString(str) {
	return typeof str !== 'string';
};

var reassembleString = function reassembleString(combine, str) {
	return isString(str) ? throwTypeError(str) : clean(str).replace(REGEX, function (sub) {
		return combine(firstChar(sub), lastChar(sub).toLowerCase());
	});
};

exports['default'] = function (combine, str) {
	return !str ? function (str) {
		return reassembleString(combine, str);
	} : reassembleString(combine, str);
};

module.exports = exports['default'];